require 'typenetwork.rb'
require 'util.rb'
#require 'pp' #prettyprint

#Dir.glob("*.gv").each do |file|

filearg = fromarg(0, "sensitive.gv")

[filearg].each do |file|
    puts "====> " + file

    begin
        net = TypeNetwork.load_network(file)
    rescue StandardError
        puts "Loading failed, continuing..."
        next
    end

    def make_print_basins net, brokennode = nil, brokenindex = nil
        endresult = {}

        1000.times do |i|
            print i.to_s + "\r"
            $stdout.flush
            net.set_random_state
            1000.times do
                net.iterate :Asynchronous
                #net.printState
                #sleep 0.01
            end
            brokennode.state = 0 if not brokennode.nil?
            state = net.statemap
            endresult[state] ||= 1
            endresult[state] += 1
        end

        resultlist = endresult.sort{|a,b| b[1]<=>a[1]}

        resultlist[0,20].each do |el|
            el[0][brokenindex] = 2 if not brokenindex.nil?
            puts el[1].to_s.rjust(5) + ": " + el[0].map{|st|
                case st
                when 0 then " "
                when 1 then "X"
                when 2 then "O"
                end
            }.join
        end

        if resultlist.size > 20
            puts "List truncated..."
        end

    end

    make_print_basins(net)

    net.nodes.each_with_index do |brokennode, brokenindex|
        puts "Disabling node #{brokenindex}"
        brokennode.mode = :Random
        make_print_basins(net, brokennode, brokenindex)
        brokennode.mode = nil
    end
end
