#!/usr/bin/env ruby

require 'fileutils'

#bytt til samme mappe som scriptet
Dir.chdir File.dirname($0)


$GlobalPrefix = "data/"

$experiments = [

	{ :Exec => "./evolve.rb -e Boxplot -n 15 -c 100 -p BasinCount -o OUTPUT",
		:Prefix => "basincount-"
	},

	{ :Exec => "./evolve.rb -e Boxplot -n 15 -c 100 -p BasinCount -p FilterBasins -o OUTPUT",
		:Prefix => "filtered-basincount-"
	},

	{ :Exec => "./evolve.rb -e Boxplot -n 15 -c 100 -p Intermediary -o OUTPUT",
		:Prefix => "intermediary-"
	},

	{ :Exec => "./evolve.rb -e Boxplot -n 15 -c 100 -p InterCompl -o OUTPUT",
		:Prefix => "intercompl-"
	},

	{ :Exec => "./evolve.rb -e Boxplot -n 15 -c 100 -p FailBasins -o OUTPUT",
		:Prefix => "failbasins-"
	},

	{ :Exec => "./evolve.rb -e Boxplot -n 15 -c 100 -p FailBasins -p StabilizePeriod -o OUTPUT",
		:Prefix => "failbasinsstabilize-"
	},

	{ :Exec => "./evolve.rb -e Boxplot -n 15 -c 100 -p FailBasins -p StabilizePeriod -p FilterBasins -o OUTPUT",
		:Prefix => "failbasinsfilterstabilize-"
	},

	{ :Exec => "./evolve.rb -e Boxplot -n 15 -c 100 -p FailBasins -p FilterBasins -o OUTPUT",
		:Prefix => "failbasinsfilter-"
	},

	{ :Exec => "./evolve.rb -e Boxplot -n 15 -c 100 -p Robustness -o OUTPUT",
		:Prefix => "robustness-"
	},
		#disabled, does not need as many samples
	#{ :Exec => "./evolve.rb -e CAComplexity -n 100 -o OUTPUT",
		#:Prefix => "wolframca-"
	#},

]

if $*[0] == "--merge"
	$experiments.each do |exp|
		allfile = $GlobalPrefix + exp[:Prefix] + "all"
		p allfile
		Dir.glob($GlobalPrefix + exp[:Prefix] + "n*").each do |file|
			`cat #{file} >> #{allfile}`
			FileUtils.rm(file)
		end
	end
	exit 0
end

def updateCount 
	$experiments.each do |exp|
		glob = $GlobalPrefix + exp[:Prefix] + "*"
		exp[:Count] = 0
		Dir.glob(glob).each do |file|
			exp[:Count] += `wc -l #{file}`.split(" ")[0].to_i
		end

	end
	$experiments.sort!{|a,b| a[:Count]<=>b[:Count]}
end

loop do
	updateCount()

	nextup = $experiments[0]
	filename = $GlobalPrefix + nextup[:Prefix]
	tryfilename = filename + "n" + (rand * 10000).to_i.to_s
	while File.exist?(tryfilename)
		tryfilename = filename + "n" + (rand * 10000).to_i.to_s
	end
	runcommand = nextup[:Exec].gsub("OUTPUT", tryfilename)
	puts runcommand

	system(runcommand)
	sleep 1
end
