require 'boolfunction.rb'

class TableFunction < BooleanFunction

    def initialize numinputs, initvalue, logictable
        super(numinputs, initvalue, nil)

		@logic = logictable
		if @logic.size != (2 ** numinputs)
			throw Exception.new("Error: function logic table is incorrectly sized")
		end

    end

	def self.makeIndex inp

		index = 0

		inp.size.times do |i|
			index += (1 << i) if inp[i] == 1
		end

		return index
	end

    def calculate_state
		i = TableFunction.makeIndex(@inputs.map{|inp| inp.state})
		@next_state = @logic[i]
    end

end
