class Array
    def find_lowest
        lowest = nil
        lowest_item = nil
        each do |item|
            val = yield(item)
            if lowest == nil or val < lowest
                lowest = val
                lowest_item = item
            end
        end
        return lowest_item
    end

    def random_item
        self[(size*rand).to_i]
    end

end

def fromarg i, default
	if $*[i]
		return $*[i]
	else
		return default
	end
end

def create_1d_ca size, rule
    net = BooleanNetwork.new
    size.times do |i|
        net.addNode(BooleanFunction.new(3, 0, rule))
    end
    net.nodes.each_with_index do |node, index|
        prevn = index==0 ? size - 1 : index - 1
        nextn = (index + 1) % size

        node.inputs[0] = net.nodes[prevn]
        node.inputs[1] = node
        node.inputs[2] = net.nodes[nextn]
    end
    return net
end

def quad_ea initialnet, count = 40
    stable = initialnet
    largestscore = yield(stable)

    #try different networks
    count.times do |neti|

        prevnet = stable.clone

        4.times do
            net = prevnet.clone
            net.randomize_nodes

            score = yield(net)

            if score > largestscore
                puts "Network ##{neti}: #{score}"
                largestscore = score
                stable = net
            end

            break if $stop
        end

        break if $stop
    end
    return stable
end

def create_random_network inputcount, networksize
	def maketable inputcount, networksize

		table = Array.new(2**inputcount)

		(2**inputcount).times do |k|

			bits = Array.new

			inputcount.times do |count|
				bit = 1 << count;

				#note: this is little-endian
				if ((k & bit) != 0)
					bits.push(1)
				else
					bits.push(0)
				end
			end

			#table[k] = bits[0] | bits[1] | bits[2]
			table[k] = (rand > 0.5)?0:1
			#puts "(" + bits.join(" ") + ") = " + table[k].to_s

		end

		return table
	end


	newnet = BooleanNetwork.new()
	networksize.times do
		newnet.addNode TableFunction.new(inputcount, 0, maketable(inputcount, networksize))
	end

	newnet.nodes.each do |node|
		inputcount.times do |i|
			input = newnet.nodes[networksize * rand]
			while node.inputs.include?(input)
				input = newnet.nodes[networksize * rand]
			end
			node.inputs[i] = input
			#puts newnet.nodes.index(node).to_s + " -> " + newnet.nodes.index(input).to_s
		end
	end
	
	newnet.description = "Random network, inputcount #{inputcount} networksize #{networksize}"
	return newnet
end

