require 'boolnetwork.rb'

class FileContentsError < StandardError; end

class YeastNetwork < BooleanNetwork


    def initialize gvfile
        super()

        file = File.read(gvfile)

        cts = {}
        #nodematch = /((\d+\s*){3,});/m.match(file)

        #raise FileContentsError if not nodematch

        #nodes = 
        #nodematch[1].split("\s").each do |id|

        #end

        file.split("\n").each do |line|
            if line.include?("->")
                m = /(\d+) \s*->\s*  (\d+) \s* \[ \s*color\s*=\s*(\w+)\s* \]/x.match(line)

                cts[m[1]] ||= []
                cts[m[1]] << [m[2], m[3]]
            end
        end

		funchash = {}

        cts.each do |from,to|

            table = Array.new(to.size)

            # for hver kombinasjon av inputs
            (2**to.size).times do |k|

				#nå har vi en kombinasjon av inputs (feks 0,1,1)
				#og må regne ut riktig sannhetsverdi basert på dette
				s = 0
				to.size.times do |i|
					if (k & (1 << i)) != 0
						case to[i][1]
						when "green"
							s += 1
						when "red"
							s -= 1
						end
					end
				end

				if s < 0
					table[k] = 1
				elsif s > 0
					table[k] = 0
				end

            end

			func = YeastFunction.new(to.size, (rand > 0.5)?0:1)
			func.name = from.to_s
			funchash[from] = func
			addNode(func)

        end

		#puts funchash

		#connect up the inputs
		cts.each do |from,toarr|
			toarr.each_with_index do |to, i|
				funchash[from].inputs[i] = funchash[to[0]]
                funchash[from].inputtypes[i] = case to[1]
                                               when "green"  then :Green
                                               when "red"    then :Red
                                               when "yellow" then :Yellow
                                               else :Undefined
                                               end
			end
		end

    end

    class YeastFunction < BooleanFunction

    attr_accessor :inputtypes

        def initialize numinputs, initvalue
            super

            @inputtypes = Array.new(numinputs)
            @has_self_arrow = nil
        end

        def calculate_state
            s = 0

            if @has_self_arrow == nil
                @has_self_arrow = @inputtypes.include?(:Yellow)
            end

            @inputs.each_with_index do |input, i|
                if input.state == 1
                    case @inputtypes[i]
                    when :Green
                        s += 1
                    when :Red
                        s -= 1
                    when :Yellow
                        #puts "yellow"
                    else
                        puts "Input type is irregular: " + @inputtypes[i].to_s
                    end
                end
            end
            if s > 0
                @next_state = 1
            elsif s < 0
                @next_state = 0
            elsif s == 0
                if @has_self_arrow == true and @state == 1
                    @next_state = 0
                end
            end

        end

        def write_inputs file
            @inputs.each_with_index do |input, i|
                typeclause = case @inputtypes[i]
                       when :Green then "[color = green]"
                       when :Red then "[color = red]"
                       when :Yellow then "[color = yellow]"
                       else ""
                       end
                file.puts(id() + " -> " + input.id() + typeclause + ";")
            end
        end

    end


end
